// PC-8801MH Demonstration (MHtN88BASIC) (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "d88.h"

static unsigned char buff[0x100*26*154];		// 256byte x 26sector x 154track
static char fname[FILENAME_MAX];				// ؂ot@C

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size) {
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos {
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[]) {
	char fname[FILENAME_MAX];
	char id[] = "ERROR";
	int i;

	// ȃf[^ʒu
	struct fpos md[] = {
		{ 0x84, 0x01, 0x1400 },
		{ 0x83, 0x0b, 0x03f0 },
		{ 0x83, 0x0f, 0x0b00 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x1a);

	// 2HD`FbN
	if (disk.GetDiskType() != disk.TYPE_2HD) {
		fprintf(stderr, "̃fBXNC[W2HDł͂Ȃ悤ł.\n");
		return 1;
	}

	disk.ReadDATA1(0x83, 0x41, 0x01, 0x01, 0x01, buff, 0x100);
	if (memcmp(&buff[0x8b],id,sizeof(id)-1)) {
		fprintf(stderr, "PC-8801MHN88-BASIC̃VXefBXNł͂Ȃ悤ł.\n");
		return 1;
	}

	// TEhhCo؂o
	fcut("DRIVER", 0x83, 0x41, 0x01, 0x01, 0x01, 0x0000, 0x0a00);
	// ȃf[^̐؂o
	for (i=0; md[i].sec; i++) {
		sprintf(fname,"MUS%02d",i);
		fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
	}

	return 0;
}

